<template>
    <div class="app-container detail" style="background-color: rgb(238, 241, 245);">
      <!-- 工单信息 -->
      <div style="padding-top: 10px;background: #fff;height: 100%;">
        <div>
          <div style="width: 5%;height: 45px;margin-left: 20px;" @click="$router.go(-1)">
            <el-button
            size="medium"
            type="text"
            style="font-size: 18px; color: rgb(7, 63, 112);float: left;"
          >返回</el-button>
          <div style="float: left;margin-top: 8px;margin-left: 5px;"><img src="../../../assets/logo/fanhui.png" style="width: 25px;" alt=""></div>
        </div>
          <!-- <el-steps :active="active" finish-status="success" simple prop="orderStatus" style="margin-top: 5px">
              <el-step title="未接收" ></el-step>
              <el-step title="已接收" ></el-step>
              <el-step title="进行中" ></el-step>
              <el-step title="已反馈" ></el-step>
              <el-step title="已归档" ></el-step>
          </el-steps> -->
        </div>

        <div style="width: 100%;height: 265px;">
          <el-divider></el-divider>
          <div style="color: #31EAEA;width: 30%;height: 30px;">
            <ul><li>详细信息</li></ul>
          </div>
          <el-form ref="form" v-model="form" :rules="rules" label-width="100px" style="float: left;margin-left: 50px;">
              <el-form-item label="巡检名称:" prop="planName">
                <font>{{form.planName}}</font>
              </el-form-item>
              <el-form-item label="检测地点:" prop="address">
                <font>{{form.address}}</font>
              </el-form-item>
              <el-form-item label="计划描述:" prop="remarks">
                <div style="height: 90px;width: 250px; border: 1px solid rgb(187, 183, 183);margin-top: 10px;overflow-y: auto;padding: 5px;border-radius: 5px;">
                    <font>{{form.remarks}}
                    </font>
                </div>
              </el-form-item>
          </el-form>
          <el-form ref="form" v-model="form" :rules="rules" label-width="100px" style="float: left;width: 25%;">
            <el-form-item label="计划执行时间:" prop="startTime">
              <font>{{form.startTime}}至{{form.endTime}}</font>
            </el-form-item>
              <el-form-item label="设备名称:" prop="deviceName">
                <!-- <font v-if="form.orderType != 1">{{form.deviceName}}</font> -->
                <el-tree
                  :data="deviceOptions"
                  :props="defaultProps"
                  :expand-on-click-node="false"
                  ref="tree"
                  @node-click="handleNodeClick"
                />
              </el-form-item>
          </el-form>
          <div id="marbox" style="width: 700px;height: 250px;float: left;margin-top: -35px; border: 1px solid rgb(218, 213, 213);">
            <div style="width: 100%;height: 100%" id="container"></div>
          </div>
        </div>
        <!-- 接单信息 -->
        <div>
          <el-divider></el-divider>
          <div style="color: #31EAEA;width: 100%;height: 40px;">
            <ul><li>接单信息</li></ul>
          </div>
          <el-form ref="form" v-model="form" :rules="rules" label-width="100px" style="margin-left: 50px;height: 30px;width: 100%;">
            <el-form-item label="下发人员:" prop="appointInspectorName" style="float: left;width: 15%;">
              <font>{{form.appointInspectorName}}</font>
            </el-form-item>
            <el-form-item label="下发时间:" prop="allotTime" style="float: left;width: 20%;">
              <font>{{form.allotTime}}</font>
            </el-form-item>
            <el-form-item label="工单编号:" prop="orderId" style="float: left;">
                <font>{{form.orderId}}</font>
              </el-form-item>
          </el-form>
        </div>
        <el-divider></el-divider>
      </div>
    </div>
  </template>

  <script>

  import { listInspectionPlan, getInspectionPlan, addInspectionPlan, updateInspectionPlan } from "@/api/deviceInspection/inspectionPlan";
  import gaodeMap from "utils/gaodeMap.js";
  import {map, DEVICE_TYPE} from "utils/gaodeMap.js";
  import { addBasicsInfo } from "@/api/workOrder/basicsInfo";
  import { inspectorList } from "@/api/system/user";
  import { deviceNodeTree } from "@/api/device/deviceInfo";
  import { deviceTree } from "@/api/device/deviceInfo";

export default {
    name: "InspectionPlan",
    components: {
    },
    data() {
      return {
         // 遮罩层
         loading: true,
        // 导出遮罩层
        exportLoading: false,
        // 选中数组
        ids: [],
        // 设备树选项
        defaultProps: {
          children: "childList",
          label: "label"
        },
        deviceOptions: [
          {
            label: "设备列表",
            childList: []
          }
        ],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 巡检计划表格数据
        inspectionPlanList: [],
        // 计划状态字典
        typeOptions: [],
        // 设备级联
        options: [],
        plansName: '',
        props: {
          multiple: true,
          value: "id",
          label: "name",
          level: "level",
          children: "childList",
        },
        devices: null,
        // 巡检员列表
        inspector: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          planName: null,
          orderId: null,
          startTime: null,
          endTime: null,
          planStatus: null,
          remarks: null
        },
        // 表单参数
        form: {  },
        // 表单校验
        rules: {
          // planName: [
          //   { required: true, message: " 计划名称不能为空", trigger: "blur" }
          // ],
          // orderName: [
          //   { required: true, message: "工单名称不能为空", trigger: "blur" }
          // ],
          // devices: [
          //   { required: true, message: "请选择巡检设备", trigger: "blur" }
          // ],
          // startTime: [
          //   { required: true, message: "请选择开始时间", trigger: "blur" }
          // ],
          // endTime: [
          //   { required: true, message: "请选择结束时间", trigger: "blur" }
          // ],
          // appointInspector: [
          //   { required: true, message: "请选择巡检人员", trigger: "blur" }
          // ],
        }
      };
    },
    created() {
      // 如果是跳转来的，则接受初始化参数
      // this.user_id = this.$route.query.id; //详细信息页接收参数
      this.planId = this.$route.query.planId;
      this.getList();
      this.getDicts("t_order_status").then(response => {
        this.typeOptions = response.data;
      });
      this.getDicts("t_order_type").then(response => {
        this.ordertypeOptions = response.data;
      });
      this.getInspectionPlan();
    },
    mounted(){
      let gaoMap =  new gaodeMap("石家庄");
      this.gaoMap = gaoMap;
      this.getInspectionPlan();
    },
    methods: {
      getInspectorList(){
        this.loading = true;
        inspectorList().then(response => {
          this.inspector = response.data;
          this.loading = false;
        });
      },
      // 点击按钮显示隐藏
      changeDisplay(e){
        this.isDisplay = !this.isDisplay
        let $timeline = this.$refs.timeline;
        if(!this.showAndHide){
          for(let i = 0; i< $timeline.$children.length; i++){
            if(i>1){
              $timeline.$children[i].$el.style.display = "block";
            }
          }
          this.showAndHide = true;
        }else{
          for(let i = 0; i< $timeline.$children.length; i++){
            if(i>1){
              $timeline.$children[i].$el.style.display = "none";
            }
          }
          this.showAndHide = false;
        }


        //$timeline.toggleRowExpansion(row,true)
      },


      handleRemove(file) {
        console.log(file);
      },
      handlePictureCardPreview(file) {
        this.dialogImageUrl = file.url;
        this.dialogVisible = true;
      },
      handleDownload(file) {
        console.log(file);
      },
      /** 查询工单基础信息列表 */
      getList() {
        this.loading = true;
        listInspectionPlan(this.queryParams).then(response => {
          this.inspectionPlanList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      },
      getInspectionPlan (){
        getInspectionPlan(this.planId).then(response =>{
          this.form = response.data;
          this.active = parseInt(response.data.orderStatus) + 1;
          console.log(this.form,2222222222222222)
          if(this.form.deviceInfoList.length>0){
            this.gaoMap.resetMapCenter([this.form.deviceInfoList[0].longitude,this.form.deviceInfoList[0].latitude]);
          }
          for(var i = 0; i < this.form.deviceInfoList.length; i++){
            let obj = this.form.deviceInfoList[i];
            this.gaoMap.addMarker(DEVICE_TYPE.WORKORDER, obj)
          }

          if(this.form.orderType == '1') {
            // 获取设备列表树
            let data = {
              key1:this.form.deviceInfoList,
              key2:this.form.pipeList
            };
            deviceTree(data).then(response => {
              this.deviceOptions[0].childList = response.data;
            });
          }
        });
      },
      // 筛选节点
      // filterNode(value, data) {
      //   if (!value) return true;
      //   return data.label.indexOf(value) !== -1;
      // },
      // 节点单击事件
      handleNodeClick(data) {

      },
      // 取消按钮
      cancel() {
        this.open = false;
        // this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          planId: null,
          orderId: null,
          orderType: null,
          orderName: null,
          orderStatus: "0",
          createTime: null,
          appointInspector: null,
          allotTime: null,
          actualInspector: null,
          actualTime: null,
          remarks: null
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.orderId)
        this.single = selection.length!==1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加工单基础信息";
      },
      /** 归档按钮操作 */
    handleFinish(res) {
      // this.reset();
      getInspectionPlan(res).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "工单信息归档";
      });
    },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        deviceNodeTree().then(response => {
          this.options = response.data;
        });
        const planId = row.planId || this.ids
        getInspectionPlan(planId).then(response => {
          this.form = response.data;
          this.form.devices = eval(this.form.deviceIds);
          this.open = true;
          this.title = "修改巡检计划";
        });
      },
      /** 提交按钮 */
       /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.orderStatus == '0') {
            updateBasicsInfo(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else if(this.form.orderStatus == '2'){
            updateOrderStatus(this.form).then(response => {
              this.msgSuccess("操作成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
      /** 删除按钮操作 */
      handleDelete(row) {
        const orderIds = row.orderId || this.ids;
        this.$confirm('是否确认删除工单基础信息编号为"' + orderIds + '"的数据项?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            return delBasicsInfo(orderIds);
          }).then(() => {
            this.getList();
            this.msgSuccess("删除成功");
          }).catch(() => {});
      },
      /** 导出按钮操作 */
      handleExport() {
        const queryParams = this.queryParams;
        this.$confirm('是否确认导出所有工单基础信息数据项?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(() => {
            this.exportLoading = true;
            return exportBasicsInfo(queryParams);
          }).then(response => {
            this.download(response.msg);
            this.exportLoading = false;
          }).catch(() => {});
      }
    }
  }
  </script>
  <style>
    .el-tree-node__content{
      width: 150px;
    }
    .el-divider--horizontal {
      display: block;
      height: 1px;
      width: 100%;
      margin: 20px 0;
    }
    .feedbackTime-div{
      float: left;margin-left: 150px;margin-top: 10px;
    }
    .feedbackTime{
      height: 120px;
      width: 120px;
      float: left;
      margin-left: 15px;
      margin-top: 5px;
      margin-bottom: 15px;
      display: flex;
      justify-content: center;
      align-items: center;
    }
    .el-card__body {
      padding: 5px 20px 20px 20px;
    }
    .detail .el-form{
        width: 20%;
    }
    .detail .el-form-item{
        margin-bottom: 0px;
    }
    .el-tree{
      margin-top: 5px;
    }
    .avatar-uploader{
        width: 25%;
        float: left;
    }
    .avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
  .avatar-uploader .el-upload:hover {
    border-color: #409EFF;
  }
  .avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 178px;
    height: 178px;
    line-height: 178px;
    text-align: center;
  }
  .avatar {
    width: 178px;
    height: 178px;
    display: block;
  }
  li{
    font-size: 15px;
    font-weight: 900;
  }
  </style>
